<?php
namespace Planejamento\Repositories;

class Itemdistcard extends \Doctrine\ORM\EntityRepository
{
    public static function BuscaEmbalagemAssociada($nrembdistcard, $nrdistcard){
        $sql = <<<SQL
SELECT NREMBDISTCARD FROM ITEMBDISTCARD WHERE NRDISTCARD=:NRDISTCARD AND NREMBDISTCARD=:NREMBDISTCARD
SQL;
        $params = array(
            'NRDISTCARD' =>$nrdistcard,
            'NREMBDISTCARD'=>$nrembdistcard
        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

        $sql=$sql[0];
        $nremb = $sql['NREMBDISTCARD'];
        if($nremb){
            $nrembdistcard = $nremb;
        }else{
            $nrembdistcard = false;
        }
        return $nrembdistcard;

    }
    public static function BuscaQtdPratoDistribuido($nrseqprat, $nrdistcard){
        $sql = <<<SQL
SELECT SUM(QTPRATO) AS QTPRATO FROM ITEMBDISTCARD WHERE NRDISTCARD=:NRDISTCARD AND
NRSEQPRATCAR=:NRSEQPRATCAR
SQL;
        $params = array(
            'NRDISTCARD' =>$nrdistcard,
            'NRSEQPRATCAR'=>$nrseqprat
        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
        $sql=$sql[0];
        $qt = $sql['QTPRATO'];
        if($qt){
            $quatidade = $qt;
        }else{
            $quantidade = false;
        }
        return $quantidade;
    }

    public static function BuscaPratoDistribuido($cdprato, $nrdistcard, $nrembdistcard, $nrseqprat){
        $sql=<<<SQL
SELECT CNF.CDPRATO, I.NRDISTCARD FROM ITEMBDISTCARD I
LEFT JOIN CNFDISTCARD CNF ON I.NRDISTCARD = CNF.NRDISTCARD AND I.NRSEQPRATCAR = CNF.NRSEQPRATCAR
WHERE CNF.CDPRATO =:CDPRATO AND I.NRDISTCARD =:NRDISTCARD AND I.NREMBDISTCARD =:NREMBDISTCARD AND CNF.NRSEQPRATCAR=:NRSEQPRAT

SQL;
        $params = array(
            'CDPRATO' =>$cdprato,
            'NRDISTCARD' =>$nrdistcard,
            'NREMBDISTCARD'=>$nrembdistcard,
            'NRSEQPRAT'=>$nrseqprat
        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function RetornaRestodePrato($nrdistcard, $nrseqprat){
        $sql=<<<SQL
SELECT CNF.QTTOTPRATO - I.QTPRATO AS RESTO FROM CNFDISTCARD CNF
LEFT JOIN ITEMBDISTCARD I ON I.NRSEQPRATCAR = CNF.NRSEQPRATCAR AND I.NRDISTCARD = CNF.NRDISTCARD
WHERE I.NRDISTCARD=:NRDISTCARD AND I.NRSEQPRATCAR=:NRSEQPRATCAR
SQL;
        $params = array(
            'NRDISTCARD' =>$nrdistcard,
            'NRSEQPRAT'=>$nrseqprat
        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function RetornaSomaPratoDistribuido($nrdistcard, $nrseqprat){
        $sql =<<<SQL
SELECT SUM(QTPRATO) SOMA
FROM ITEMBDISTCARD
GROUP BY NRDISTCARD,
NRSEQPRATCAR HAVING NRDISTCARD =:NRDISTCARD AND NRSEQPRATCAR =:NRSEQPRATCAR
SQL;

        $params = array(
            'NRDISTCARD' =>$nrdistcard,
            'NRSEQPRATCAR'=>$nrseqprat
        );
        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function RetornaSomaComensaisDistribuido($nrdistcard, $nrseqprat){
        $sql =<<<SQL
SELECT SUM(QTCOMENSAIS) SOMA
FROM ITEMBDISTCARD
GROUP BY NRDISTCARD,
  NRSEQPRATCAR HAVING NRDISTCARD =:NRDISTCARD AND NRSEQPRATCAR =:NRSEQPRATCAR
SQL;

        $params = array(
            'NRDISTCARD' =>$nrdistcard,
            'NRSEQPRATCAR'=>$nrseqprat
        );
        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function RetornaTotalDistribuido($nrdistcard){
        $sql=<<<SQL
SELECT DISTINCT PRATOC.SOMA - PRATOI.SOMA AS RESTO
FROM ITEMBDISTCARD
INNER JOIN CNFDISTCARD CNF
ON CNF.NRDISTCARD = ITEMBDISTCARD.NRDISTCARD
LEFT JOIN
  (SELECT NRDISTCARD, SUM(QTPRATO) SOMA FROM ITEMBDISTCARD GROUP BY NRDISTCARD
  ) PRATOI
ON PRATOI.NRDISTCARD = ITEMBDISTCARD.NRDISTCARD
LEFT JOIN
  (SELECT NRDISTCARD, SUM(QTTOTPRATO) SOMA FROM CNFDISTCARD GROUP BY NRDISTCARD
  ) PRATOC
ON PRATOC.NRDISTCARD   = CNF.NRDISTCARD
WHERE PRATOI.NRDISTCARD=:NRDISTCARD
SQL;
        $params = array('NRDISTCARD' =>$nrdistcard);
        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

}