package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class CalendarioDeCardapioPage extends PageBase {

    By Inicio = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By pesquisaTela = By.xpath("//section[@class = 'zh-container-search-menu']/input");
    By selecionaTela = By.xpath("//span[text() = 'Calendário de Cardápio']");
    By telaCalendarioDeCardapio = By.xpath("//div[text() = 'Calendário de Cardápio']");
    By mesCardapioFechado = By.xpath("//span[text() = 'Março']");
    By mesCardapio = By.xpath("//span[text() = 'Janeiro']");
    By limpaCampoAno = By.xpath("//div[@id = 'DTANOCALENCARD']//span[@zh-icon='no-border close-x']");
    By clicaCampoAno = By.xpath("//div[@id = 'DTANOCALENCARD']");
    By anoCalendarioCardapio = By.xpath("//div[@data-val='2024']");
    By btnSelecionarAno = By.xpath("//div[text() = 'Selecionar']");
    By btnAplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro']");
    By btnAcoes = By.xpath("//span[text() = 'Ações']");
    By btnExportarCalendario = By.xpath("//span[text() = 'Exportar Calendário de Cardápio']");
    By btnLogCalendarioCardapio = By.xpath("//span[text() = 'Log Calendário de Cardápio']");
    By btnVoltar = By.xpath("//span[text() = 'Voltar']");
    By novoFiltro = By.xpath("//span[@data-zh-icon='filter no-border icon-white']");
    By limpaFiltroUnidade = By.xpath("//div[@id ='CDFILIAL_FILTER']//span[@zh-icon='no-border close-x']");
    By buscaUnidade = By.xpath("//div[@id ='CDFILIAL_FILTER']//span[@zh-icon='no-border search']");
    By btnEditar = By.xpath("//li[@data-zh-id='66364606739248223931427']");
    By btnSalvar = By.xpath("//span[text() = 'Salvar']");
    By clicaPrevisaoLiberacao = By.xpath("//div[@class = 'zh-select-date zh-field-DTPREVLIBECARD']");
    By previsaoLiberacao = By.xpath("//input[@id = 'DTPREVLIBECARD']");
    By diasAprovacaoUnidade = By.xpath("//input[@id = 'QTDIAPROFIL']");
    By limiteAprovacaoAprovacaoUnidade = By.xpath("//input[@id = 'DTLIMAPROVFILI']");
    By diasAprovacaoMatriz = By.xpath("//input[@id = 'QTDIAPROMAT']");
    By limiteAprovacaoMatriz = By.xpath("//input[@id = 'DTLIMAPROVMATR']");
    By limpaDataAprovFilial = By.xpath("//div[@data-zh-id='66364606726777470201419']//span[@zh-icon='no-border close-x']");
    By limpaDataAprovMatriz = By.xpath("//div[@data-zh-id='6636460676708352121423']//span[@zh-icon='no-border close-x']");
    By diasProrrogacao = By.xpath("//input[@id = 'QTDIAPRORAPROV']");
    By custoBaseCardapio = By.xpath("//input[@id = 'DTBASCONCUSPLAN']");
    By limpaPrevisaoLiberacao = By.xpath("//div[@class = 'zh-select-date zh-field-DTPREVLIBECARD']//span[@zh-icon='no-border close-x']");
    By validaDataPrevisaoLiberacao = By.xpath("//p[text() = '31/12/2022']");
    By validaDataAprovacaoUnidade = By.xpath("//p[text() = '02/01/2023']");
    By validaDataAprovacaoMatriz = By.xpath("//p[text() = '05/01/2023']");
    By validaDataCustoCardapio = By.xpath("//p[text() = '01/01/2023']");

    //Prorrogação Automática
    By btnProrrogacaoAutomatica = By.xpath("//span[text() = 'Prorrogação Automática']");
    By lupaAgrupamentoUnidade = By.xpath("//div[@id= 'NMGRUPFILI']//span[@zh-icon='no-border search']");
    By informaBusca = By.xpath("//*[@id= 'popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaBusca = By.xpath("//section[@data-zh-id='9000']//*[@class = 'tr cell1']");
    By checkBoxTodasUnidades = By.xpath("//*[@zh-icon='checked no-border']");
    By campoUnidade = By.xpath("//div[@name = 'CDFILIAL']");
    By selecionaUnidade = By.xpath("//div[@class= 'th grid-checkbox-column fixed']");
    By btnOk = By.xpath("//span[text() = 'Ok']");
    By mesAprovacao = By.xpath("//div[@id = 'MESAPRORAPROV']");
    By clicaAbril = By.xpath("//div[@class = 'dw-i']//span[text() = 'Abril']");
    By clicaFevereiro = By.xpath("//div[@class = 'dw-i']//span[text() = 'Fevereiro']");
    By selecionaMesCardapio = By.xpath("//div[@class = 'dw-i']//span[text() = 'Janeiro']");
    By selecionaAnoCardapio = By.xpath("//div[text() = '2024']");
    By btnSelecionar = By.xpath("//div[text() = 'Selecionar']");
    By qtdDiasProrrogacao = By.xpath("//input[@name = 'QTDIAPRORAPROV']");
    By btnProrrogar = By.xpath("//li[@data-zh-id='6636460673117284607292']");
    By confirmaAlerta = By.xpath("//button[@class = 'zh-alert-button']");
    By retornaDiasProrrogacao = By.xpath("//*[@id='grid-66364606719142602381413']/div[2]/div/div[1]/div[7]/span");

    //Exportar Calendário de Cardápio

    By anoOrigem = By.xpath("//div[@id = 'ANO_ORIGEM']");
    By limpaAnoOrigem = By.xpath("//div[@name = 'ANO_ORIGEM']//span[@zh-icon='no-border close-x']");
    By campoCalendario = By.xpath("//div[@id = 'CALENDARIO']");
    By marcaMesExportacao = By.xpath("//div[@class = 'th grid-checkbox-column fixed']");
    By anoDestino = By.xpath("//div[@id = 'ANO_DESTINO']");
    By agrupamentoUnidade = By.xpath("//div[@name= 'NMGRUPFILI']//span[@zh-icon = 'no-border search']");
    By checkBoxTodasFiliais = By.xpath("//label[@for= 'zh-checkbox-T_CDFILIAL']//span[@zh-icon = 'checked no-border']");
    By campoUnidadeDestino = By.xpath("//div[@id = 'CDFILIAL_DESTINO']");
    By btnExportar = By.xpath("//li[@data-zh-id='6636460672334663362267']//span[text() = 'Exportar']");
    By previsaoLiberacaoCard = By.xpath("//span[text() = '31/12/2022']");
    By diasAprovUnidade = By.xpath("//div[@data-zh-field-name='QTDIAPROFIL']//span[text() = '2']");
    By limiteAprovacaoUnidade = By.xpath("//input[@id = 'DTLIMAPROVFILI']");
    By limiteAprovUnidade = By.xpath("//span[text() = '02/01/2023']");
    By diasAprovMatriz = By.xpath("//div[@data-zh-field-name='QTDIAPROMAT']//span[text() = '3']");
    By limiteAprovMatriz = By.xpath("//div[@data-zh-field-name='DTLIMAPROVMATR']//span[text() = '05/01/2023']");
    By diasProrrogacaoAprov = By.xpath("//div[@data-zh-field-name='QTDIAPRORAPROV']//span[text() = '5']");
    By custoBaseCardapioAprov = By.xpath("//div[@data-zh-field-name='DTBASCONCUSPLAN']//span[text() = '01/01/2023']");

    //Log de calendário
    By btnConfirmar = By.xpath("//div[@class = 'zh-footer-right']//li[@data-zh-id='6636460673716964049275']//span[text() = 'Confirmar']");

    public void acessaTelaCalendarioCardapio(){
        waitForElement(Inicio);
        tempo();
        click(clicaMenu);
        tempo();
        click(pesquisaTela);
        clearAndSendKeys(pesquisaTela,"Calendário de Cardápio");
        tempo();
        click(selecionaTela);
        tempo();
        click(btnAplicarFiltro);
        tempo();
    }
    public String validaAcessoTela(){
        return getText(telaCalendarioDeCardapio);
    }
    public void clicaMesCardapioFechado(){
        tempo();
        click(mesCardapioFechado);
        tempo();
        click(btnVoltar);
        tempo();
    }
    public void validaCamposObrigatorios(){
        click(novoFiltro);
        tempo();
        click(limpaCampoAno);
        tempo();
        click(clicaCampoAno);
        tempo();
        click(anoCalendarioCardapio);
        tempo();
        click(btnSelecionarAno);
        tempo();
        click(btnAplicarFiltro);
        tempo();
        click(mesCardapio);
        tempo();
        click(btnEditar);
        tempo();
        click(limpaPrevisaoLiberacao);
        tempo();
        click(btnSalvar);
        tempo();
    }
    public void insereCalendarioCardapio(){
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(clicaPrevisaoLiberacao), -200, 0).click().build().perform();
        tempo();
        clearAndSendKeys(previsaoLiberacao,"31/12/2022");
        tempo();
        click(custoBaseCardapio);
        clearAndSendKeys(custoBaseCardapio,"01/01/2023");
        tempo();
        click(btnSalvar);
        tempo();


    }
    public void insereDataMenorAprovFilial(){
        tempo();
        click(btnEditar);
        tempo();
        click(limpaDataAprovFilial);
        click(limiteAprovacaoAprovacaoUnidade);
        tempo();
        clearAndSendKeys(limiteAprovacaoAprovacaoUnidade,"01/11/2022");
        tempo();
        click(btnSalvar);
        tempo();
        click(confirmaAlerta);
        tempo();
        click(diasAprovacaoUnidade);
        clearAndSendKeys(diasAprovacaoUnidade,"2");
        tempo();
        click(btnSalvar);
        tempo();
    }
    public void insereDataMenorAprovMatriz(){
        tempo();
        click(btnEditar);
        tempo();
        click(limpaDataAprovMatriz);
        click(limiteAprovacaoMatriz);
        tempo();
        clearAndSendKeys(limiteAprovacaoMatriz,"01/01/2023");
        tempo();
        click(btnSalvar);
        tempo();
        click(confirmaAlerta);
        tempo();
        click(diasAprovacaoMatriz);
        clearAndSendKeys(diasAprovacaoMatriz,"3");
        tempo();
        click(btnSalvar);
        tempo();
    }
    public void alteraDataCalendario(String NRDIASPRORROG){
        click(btnEditar);
        tempo();
        click(diasAprovacaoUnidade);
        clearAndSendKeys(diasAprovacaoUnidade,"2");
        tempo();
        click(diasAprovacaoMatriz);
        clearAndSendKeys(diasAprovacaoMatriz,"3");
        tempo();
        click(diasProrrogacao);
        clearAndSendKeys(diasProrrogacao,NRDIASPRORROG);
        tempo();
        click(btnSalvar);
        tempo();
    }
    public String validaDataLiberacao(){
        return getText(validaDataPrevisaoLiberacao);
    }
    public String validaDataAprovacaoUnidade(){
        return getText(validaDataAprovacaoUnidade);
    }
    public String validaDataAprovacaoMatriz(){
        return getText(validaDataAprovacaoMatriz);
    }
    public String validaDataCusto() {
        return getText(validaDataCustoCardapio);
    }
    public void prorrogacaoAutomatica(){
        tempo();
        click(novoFiltro);
        tempo();
        click(limpaCampoAno);
        tempo();
        click(clicaCampoAno);
        tempo();
        click(anoCalendarioCardapio);
        tempo();
        click(btnSelecionarAno);
        tempo();
        click(btnAplicarFiltro);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnProrrogacaoAutomatica);
        tempo();
        click(btnProrrogar);
        tempo();
        clickPerform(mesAprovacao);
        tempo();
        click(clicaAbril);
        click(clicaFevereiro);
        tempo();
        click(selecionaMesCardapio);
        tempo();
        click(selecionaAnoCardapio);
        tempo();
        click(btnSelecionar);
        tempo();
        clickPerform(qtdDiasProrrogacao);
        clearAndSendKeys(qtdDiasProrrogacao,"5");
        tempo();
        click(btnProrrogar);
        tempo();
        click(confirmaAlerta);
        tempo();
    }
    public String validaDiasProrrogacao(){
        return getText(retornaDiasProrrogacao);
    }
    public void prorrogadiasUnidades(String NRDIAS){
        tempo();
        click(btnAcoes);
        tempo();
        click(btnProrrogacaoAutomatica);
        tempo();
        click(lupaAgrupamentoUnidade);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca,"0000000002");
        tempo();
        click(selecionaBusca);
        tempo();
        click(checkBoxTodasUnidades);
        click(campoUnidade);
        tempo();
        click(selecionaUnidade);
        click(btnOk);
        tempo();
        click(mesAprovacao);
        tempo();
        click(clicaAbril);
        click(clicaFevereiro);
        tempo();
        click(selecionaMesCardapio);
        tempo();
        click(selecionaAnoCardapio);
        tempo();
        click(btnSelecionar);
        tempo();
        click(qtdDiasProrrogacao);
        clearAndSendKeys(qtdDiasProrrogacao,NRDIAS);
        tempo();
        click(btnProrrogar);
        tempo();
        click(confirmaAlerta);
        tempo();
    }
    public void exportarCalendarioCardapio(){
        tempo();
        click(novoFiltro);
        tempo();
        click(limpaCampoAno);
        tempo();
        click(clicaCampoAno);
        tempo();
        click(anoCalendarioCardapio);
        tempo();
        click(btnSelecionarAno);
        tempo();
        click(btnAplicarFiltro);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnExportarCalendario);
        tempo();
        click(btnExportar);
        tempo();
        clickPerform(anoOrigem);
        tempo();
        click(selecionaAnoCardapio);
        tempo();
        click(btnSelecionar);
        tempo();
        clickPerform(campoCalendario);
        tempo();
        click(marcaMesExportacao);
        click(btnOk);
        tempo();
        clickPerform(anoDestino);
        tempo();
        click(selecionaAnoCardapio);
        click(btnSelecionar);
        tempo();
        click(checkBoxTodasFiliais);
        click(campoUnidadeDestino);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca,"0002");
        tempo();
        click(selecionaUnidade);
        tempo();
        click(btnOk);
        tempo();
        click(btnExportar);
        tempo();
        click(confirmaAlerta);
        tempo();
        click(novoFiltro);
        tempo();
        click(limpaFiltroUnidade);
        click(buscaUnidade);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca,"0002");
        tempo();
        click(selecionaBusca);
        tempo();
        click(btnAplicarFiltro);
        tempo();

    }
    public String validaPrevisaoLiberacao() {
        return getText(previsaoLiberacaoCard);
    }
    public String validaDiasAprovacaoUnidade() {
        return getText(diasAprovUnidade);
    }
    public String validaLimiteAprovacaoUnidade() {
        return getText(limiteAprovUnidade);
    }
    public String validaDiasAprovacaoMatriz() {
        return getText(diasAprovMatriz);
    }
    public String validaLimiteAprovacaoMatriz() {
        return getText(limiteAprovMatriz);
    }
    public String validaDiasProrrogacaoAprovacao() {
        return getText(diasProrrogacaoAprov);
    }
    public String validaCustoBaseCardapio() {
        return getText(custoBaseCardapioAprov);

    }
    public void logCalendarioCardapio(){
        tempo();
        click(btnAcoes);
        tempo();
        click(btnLogCalendarioCardapio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
    }





}
