package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.HistoricoRequisicaoFlows;
import com.javaseleniumtemplate.pages.HistoricoRequisicaoPage;
import org.testng.annotations.Test;

public class HistoricoRequisicaoTests extends TestBase {

    HistoricoRequisicaoPage historicoRequisicaoPage;
    HistoricoRequisicaoFlows historicoRequisicaoFlows;
    LoginFlows loginFlows;

    @Test
    public void relatorioAnaliticoData() {
        emitiRelatorio("Histórico de Requisição (Analítico por Data)");
    }

    @Test
    public void relatorioSinteticoData() {
        emitiRelatorio("Histórico de Requisição (Sintético por Data)");
    }

    @Test
    public void relatorioSinteticoOperador() {
        emitiRelatorio("Histórico de Requisição (Sintético por Operador)");
    }

    @Test
    public void relatorioAnaliticoOperador() {
        emitiRelatorio("Histórico de Requisição (Analítico por Operador)");
    }


    //selecionar o relatório que será gerado
    //selecionar a unidade jabaquara
    //preencher as datas inicial e final
    //gerar o relatório, com as opções de operador e seviço, com o campo "todos" marcado
    //fechar a guia do relatório
    //selecionar alguns operadores e serviços
    //gerar novamente o relatório
    //fechar a guia com o relatório e atualizar a tela
    //deixar os campos unidade, data, operador e serviço vazios
    //tentar gerar um relatório com estes campos vazios e verificar os campos obrigatórios
    public void emitiRelatorio(String relatorio) {
        historicoRequisicaoPage = new HistoricoRequisicaoPage();
        historicoRequisicaoFlows = new HistoricoRequisicaoFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/02/2023";
        String dataFinal = "30/04/2023";

        loginFlows.efetuarLogin();
        historicoRequisicaoFlows.navegateHistoricoRequisicao();
        historicoRequisicaoPage.selecionaRelatorio(relatorio);
        historicoRequisicaoPage.selecionarUnidadeJabaquara();
        historicoRequisicaoPage.preencherDatas(dataInicial, dataFinal);
        historicoRequisicaoPage.geraRelatorio();
        historicoRequisicaoPage.selecionarAlgunsOperadores();
        historicoRequisicaoPage.selecionarServicos();
        historicoRequisicaoPage.geraRelatorio();
        historicoRequisicaoPage.refresh();
        historicoRequisicaoPage.selecionaRelatorio(relatorio);
        historicoRequisicaoPage.camposObrigatorios();

        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

}
